"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineAnnotation = void 0;
const markupAnnotation_1 = require("./markupAnnotation");
class LineAnnotation extends markupAnnotation_1.MarkupAnnotation {
    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(LineAnnotation.attributeTypeMap);
    }
}
exports.LineAnnotation = LineAnnotation;
LineAnnotation.discriminator = undefined;
LineAnnotation.attributeTypeMap = [
    {
        "name": "starting",
        "baseName": "Starting",
        "type": "Point"
    },
    {
        "name": "startingStyle",
        "baseName": "StartingStyle",
        "type": "LineEnding"
    },
    {
        "name": "ending",
        "baseName": "Ending",
        "type": "Point"
    },
    {
        "name": "endingStyle",
        "baseName": "EndingStyle",
        "type": "LineEnding"
    },
    {
        "name": "interiorColor",
        "baseName": "InteriorColor",
        "type": "Color"
    },
    {
        "name": "leaderLine",
        "baseName": "LeaderLine",
        "type": "number"
    },
    {
        "name": "leaderLineExtension",
        "baseName": "LeaderLineExtension",
        "type": "number"
    },
    {
        "name": "leaderLineOffset",
        "baseName": "LeaderLineOffset",
        "type": "number"
    },
    {
        "name": "showCaption",
        "baseName": "ShowCaption",
        "type": "boolean"
    },
    {
        "name": "captionOffset",
        "baseName": "CaptionOffset",
        "type": "Point"
    },
    {
        "name": "captionPosition",
        "baseName": "CaptionPosition",
        "type": "CaptionPosition"
    },
    {
        "name": "intent",
        "baseName": "Intent",
        "type": "LineIntent"
    }
];
//# sourceMappingURL=lineAnnotation.js.map